
import "wtypes.idl";

[
    uuid(6F818C55-E6AD-488b-9EB6-511C0CCC0612),
    version(1.0)
]
library SLApp
{
	importlib("stdole32.tlb");
	[ 
	  uuid(7F24AABF-C822-4c18-9432-21433208F4DC),
	  dual,
	  oleautomation 
	]
	interface IScilabApp : IDispatch
	{
        [id(1)] int putCommand(BSTR objectname);
		[id(2)] int Execute(BSTR commandLine);
        [id(3)] int Quit(void);

		[id(4)] HRESULT getScalarDouble([in] BSTR varname,   [out, retval] double* pValue);
		[id(5)] HRESULT getScalarString([in] BSTR varname,  [out, retval] BSTR* strval);
        [id(6)] HRESULT getScalarBoolean([in] BSTR varname,  [out, retval] VARIANT_BOOL* pValue);

        [id(7)] HRESULT createScalarDouble([in] BSTR varname,   [in] double pValue);
		[id(8)] HRESULT createScalarString([in] BSTR varname,  [in] BSTR strval);
        [id(9)] HRESULT createScalarBoolean([in] BSTR varname,  [in] VARIANT_BOOL bValue);

		[id(10)] HRESULT getComplexMatrixOfDouble([in] BSTR varname,  [in, out] SAFEARRAY(double) *pr, [in, out] SAFEARRAY(double) *pi);

		
		[id(11)] HRESULT getMatrixOfDouble([in] BSTR varname,  [out, retval] SAFEARRAY(double) *pr);
		[id(12)] HRESULT createMatrixOfDouble([in] BSTR varname,  [in] SAFEARRAY(double) *pr);

		[id(13)] HRESULT isNamedVarExist([in] BSTR varname, [out, retval] VARIANT_BOOL* isExist);

		[propget] HRESULT Visible([out, retval] VARIANT_BOOL* pValue);
        [propput] HRESULT Visible([in] VARIANT_BOOL newValue) ;

	}


	[ uuid(6AE24C34-1466-482e-9407-90B98798A712),
	  helpstring("Scilab Application object") 
	]
	coclass CoCOMServer
	{
		[default] interface IScilabApp;
	}
}

